/*Pklad komunikace s interfejsem Disp1704 pro Raspberry PI B+ */


#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
#include <string.h>
#include <time.h>
#include <bcm2835.h>
#include <errno.h>
#include <math.h>
#include "rkods.h"


char bargr1[] = {
 0x00, 0x0, 0x10, 0x10, 0x10, 0x10, 0x10, 0, // |	
 0x00, 0x0, 0x10, 0x10, 0x14, 0x14, 0x14, 0, // ||
 0x00, 0x0, 0x10, 0x10, 0x15, 0x15, 0x15, 0, // |||   
      
};

char bargr2[] = {
 0x00, 0x0, 0x0, 0x10, 0x10, 0x10, 0x10, 0, // |	
 0x00, 0x0, 0x0, 0x14, 0x14, 0x14, 0x14, 0, // ||
 0x00, 0x0, 0x0, 0x15, 0x15, 0x15, 0x15, 0, // |||   
      
};

char bargr3[] = {
 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0, // |	
 0x14, 0x14, 0x14, 0x14, 0x14, 0x14, 0x14, 0, // ||
 0x15, 0x15, 0x15, 0x15, 0x15, 0x15, 0x15, 0, // |||      
};

char ASCII[] = {
 0x02, 0x04, 0x0E, 0x01, 0x0F, 0x11, 0x0F, 0, // 
 0x0A, 0x04, 0x0E, 0x10, 0x10, 0x11, 0x0E, 0, // 
 0x0A, 0x04, 0x0E, 0x11, 0x1F, 0x10, 0x0E, 0, //  
 0x02, 0x04, 0x0C, 0x04, 0x04, 0x04, 0x0E, 0, //  
 0x0A, 0x04, 0x16, 0x19, 0x10, 0x10, 0x10, 0, //  
 0x0A, 0x04, 0x0E, 0x10, 0x0E, 0x01, 0x1E, 0, //  
 0x02, 0x04, 0x11, 0x11, 0x11, 0x13, 0x0D, 0, // 
 0x02, 0x04, 0x11, 0x11, 0x0F, 0x01, 0x0E, 0  //           
};

char str[32]="Men kmitotu:";
char text[32]= "Tlatko: ";
char buf[32];

int main (int argc, char *argv [])
{
int temp=0,vol=0, vdd=0, dsize=0, butn=0;
char chr;

 if(!bcm2835_init()) return 1;
 
  bcm2835_i2c_setSlaveAddress(0x10);  //adresaI2C
  bcm2835_i2c_setClockDivider(2400);  // rychlost
  bcm2835_i2c_begin();					// start I2C
 
while(1){

  buf[0]=CMND; buf[1]= 0x1;			//inicializace displeje
  bcm2835_i2c_write(buf,2);			//
  
  buf[0]=DMOD; buf[1]= FQE2; //freq on   start men frekvence, zobrazen na 2. dku
  bcm2835_i2c_write(buf,2); 
  delay(2000);					// pauza
  
  buf[0]=TEMP; 
  bcm2835_i2c_write(buf,1);  //temp   nast teplotu ipu
  bcm2835_i2c_read(buf, 2);
  temp=buf[0] + (buf[1]<<8);
  
  buf[0]=VDD; 			//vdd	nast pomrmezi Vdd a vnitn referenc
  bcm2835_i2c_write(buf,1);
  bcm2835_i2c_read(buf, 2);
  vdd=buf[0] + (buf[1]<<8);
  
  buf[0]=VOLT; 			//vol	nast napt na pinu RC3 
  bcm2835_i2c_write(buf,1);
  bcm2835_i2c_read(buf, 2);
  vol=buf[0] + (buf[1]<<8);
   
  buf[0]=CMND; buf[1]= ROW1+2;   // nastavit kurzor na 2. pozici 1. dku
  bcm2835_i2c_write(buf,2);
  
  bcm2835_i2c_write(str,strlen(str));    // vyslat obsak etzce str
  
  buf[0]=BUTN; 						// Tla naqst stav tlatek
  bcm2835_i2c_write(buf,1);
  bcm2835_i2c_read(buf, 1);
  butn=buf[0];
  
  buf[0]=CMND; buf[1]= ROW4;			// kurzor nazatek 4. dku
  bcm2835_i2c_write(buf,2);
  buf[0]=butn+0x30;						// 
  bcm2835_i2c_write(text,strlen(text));	// vyslat text
  bcm2835_i2c_write(buf,1);				// vyslat stav tlatek
  
  buf[0]=DMOD; buf[1]= FNT1; //bargraf font 1
  bcm2835_i2c_write(buf,2);
  
  buf[0]=CMND; buf[1]= COFF; //curs off
  bcm2835_i2c_write(buf,2);
  
  buf[0]=CMND; buf[1]= ROW3;  //kurzor na 3. dek
  bcm2835_i2c_write(buf,2);  
 
   buf[0]=BARG; buf[1]= 60; // bargraf na dlku 60
   bcm2835_i2c_write(buf,2); 
  delay(100);
  
  buf[0]=CMND; buf[1]= CON; //curs on
  bcm2835_i2c_write(buf,2);
  
  buf[0]=CMND; buf[1]= ROW2+15;  //kurzor na pozici 15 na 2. dku
  bcm2835_i2c_write(buf,2);
   
  delay(100);
  
  buf[0]=BRIG; buf[1]= 0x00;   //osvtlen  nebo doladn osciltoru
  bcm2835_i2c_write(buf,2);
 
  buf[0]=BUFF; 					//buffer   nate zaplnn kruhovho bufferu
  bcm2835_i2c_write(buf,1);
  bcm2835_i2c_read(buf, 1);
  dsize = buf[0];
 
  buf[0]=RTXT; 				//text    nate identifikaci interfejsu nebo zmenou frekvenci
  bcm2835_i2c_write(buf,1);

  bcm2835_i2c_read(buf, 16);  
  
  printf("%s\n", buf);         // vype daje
  printf("bt= 0x%x\n", butn);
  printf("temp= 0x%x\n", temp);
   printf("V= 0x%x\n", vol);
   printf("Vdd= 0x%x\n", vdd);
   printf("Buf= %d\n", dsize);
  
  chr= getchar();
  if(chr == 0x20) break;    //je-li mezernk, konec
}
  buf[0]=RSET; 				// vyle softwarov reset
 bcm2835_i2c_write(buf,1);
 
  bcm2835_i2c_end();		// ukon I2C
 

 bcm2835_close();			// ukon md bcm
//--------------------------------------
 return 0;
}
